//#include <stdio.h>
//#include <stdlib.h>
#include <iostream>
using namespace std;

typedef struct rezult {
   char sign;
   long res;
} rezult_t;                                   // тип возвращаемых структур

typedef rezult_t( test_fun ) ( long, long );  // тип функций тестов
test_fun test1, test2, test3, test4;          // предварительные описания

rezult_t ( *tests[] )( long, long ) = {       // последовательность тестов
        test1, test2, test3, test4            // ...
        };

inline void show_test( long o1, long o2, rezult_t r ) {
   cout << o1 << ' ' << r.sign << ' ' << o2 << " = " << r.res << endl; 
}

int main( int argc, char **argv ) {
   long o1, o2;
   while( 1 ) {
      cout << "введите 2 целых операнда: ";
      cin >> o1 >> o2;
      for( unsigned int k = 0; 
           k < sizeof( tests ) / sizeof( tests[ 0 ] ); k++ )
         show_test( o1, o2, tests[ k ]( o1, o2 ) );
   }
   return 0;
}

rezult_t test1( long o1, long o2 ) { 
   rezult_t r = { '+' };
   r.res = o1 + o2;
   return r; 
}

rezult_t test2( long o1, long o2 ) { 
   rezult_t r = { '-' };
   r.res = o1 - o2;
   return r; 
}

rezult_t test3( long o1, long o2 ) { 
   rezult_t r = { '*' };
   r.res = o1 * o2;
   return r; 
}

rezult_t test4( long o1, long o2 ) { 
   rezult_t r = { '/' };
   r.res = o1 / o2;
   return r; 
}

