#include <iostream>
using namespace std;

typedef void( test_fun ) ( long, long );  // тип функций тестов
test_fun test1, test2, test3, test4;      // предварительные описания

int main( int argc, char **argv ) {
   long o1, o2;
   void ( *tests[] )( long, long ) = {    // последовательность тестов
           test1, test2, test3, test4,    // ...
        };
   while( 1 ) {
      cout << "введите 2 целых операнда: ";
      cin >> o1 >> o2;
      for( unsigned int k = 0; 
           k < sizeof( tests ) / sizeof( tests[ 0 ] ); k++ )
         tests[ k ]( o1, o2 );
   }
   return 0;
}

inline void show_test( char sign, long o1, long o2, long res ) {
   cout << o1 << ' ' << sign << ' ' << o2 << " = " << res << endl; 
}

void test1( long o1, long o2 ) { show_test( '+', o1, o2, o1 + o2 ); }

void test2( long o1, long o2 ) { show_test( '-', o1, o2, o1 - o2 ); }

void test3( long o1, long o2 ) { show_test( '*', o1, o2, o1 * o2 ); }

void test4( long o1, long o2 ) { show_test( '/', o1, o2, o1 / o2 ); }
